#define _GNU_SOURCE
#include <sys/types.h>
#include <pwd.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <string.h>

void *dlopen(const char *filename, int flags)
{
  static void * (*func)(const char *filename, int flags);
  static uid_t my_uid;
  static char *override;
  struct passwd *p;

  if(!func) {
    func = (void *(*)(const char *filename, int flags))
      dlsym(RTLD_NEXT, "dlopen");
  }
  if (strcmp(filename, "/usr/lib64/libnfsidmap/files.so") == 0) {
    return func(".libs/files.so", flags);
  } else {
    return func(filename, flags);
  }
}
